#include <iostream>
#include <fstream>
#include <stdio.h>
#include <vector>
#include <cstring>
#include <math.h>
using namespace std;

int main(int argc, char *argv[]) {
	streampos size;
	char * memblock;
	uint64_t rel_number_ngrams1 = 0;
	uint64_t total_number_ngrams1 = 0;

	char num_string[20];

	vector<uint64_t> arr;
	uint64_t i = 0;
	int c = 0;

	if (argc != 2) {
		cout << "Wrong Arguments." << endl << "Usage:" << endl << "entropy [input file]" << endl;
		cout << "Input file needs to be one byte encoded ISO8592" << endl;
		return(1);
	}

	ifstream file1(argv[1], ios::in | ios::binary | ios::ate);

	if (file1.is_open())
	{
		size = file1.tellg();
		memblock = new char[size];
		file1.seekg(0, ios::beg);
		file1.read(memblock, size);
		while (i < (uint64_t)size - 1) {
			if (memblock[i] == ';') {
				rel_number_ngrams1++;
				c = 1;
				while (c != 0) {
					if (memblock[i + c] == 0x0A) {
						memcpy(num_string, &memblock[i + 1], c - 1);
						i = i + c;
						num_string[c - 1] = '\0';
						total_number_ngrams1 += atoi(num_string);
						arr.push_back(atoi(num_string));
						c = 0;
					}
					else {
						c++;
					}
				}
			}
			i++;
		}
		cout << "Number of different NGrams: " << rel_number_ngrams1 << endl;
		cout << "Total number of NGrams: " << total_number_ngrams1 << endl;
		delete[] memblock;

		double sum = 0;
		double prob;

		for (i = 0; i < rel_number_ngrams1; i++) {
			prob = 1.0*arr[i] / (1.0*total_number_ngrams1);
			sum += prob*log2(prob);
		}
		cout << "Sum: " << sum << endl;
	}
	file1.close();
}
