#include <iostream>
#include <fstream>
#include <stdio.h>
#include <vector>
#include <math.h>
#include "Hashtable.h"
using namespace std;

int main(int argc, char *argv[]) {
	streampos size;
	Hashtable ht;
	

	char * memblock;
	__int64 rel_number_ngrams1 = 0;
	__int64 total_number_ngrams1 = 0;
	__int64 bucket_size;
	__int64 bucket;

	char num_string[20];

	int i = 0;
	int c = 0;

	if (argc != 4) {
		cout << "Wrong Arguments." << endl << "Usage:" << endl << "histogramm [bucket size] [input file] [output file]" << endl;
		cout << "Input file needs to be one byte encoded ISO8592" << endl;
		return(1);
	}

	bucket_size = atoi(argv[1]);

	ifstream file1(argv[2], ios::in | ios::binary | ios::ate);

	if (file1.is_open())
	{
		size = file1.tellg();
		memblock = new char[size];
		file1.seekg(0, ios::beg);
		file1.read(memblock, size);
		while (i < (int)size - 1) {
			if (memblock[i] == ';') {
				rel_number_ngrams1++;
				c = 1;
				while (c != 0) {
					if (memblock[i + c] == 0x0A) {
						memcpy(num_string, &memblock[i + 1], c - 1);
						i = i + c;
						num_string[c - 1] = '\0';
						bucket = atoi(num_string) / bucket_size;
						ht.plus_one(bucket);
						c = 0;
					}
					else {
						c++;
					}
				}
			}
			i++;
		}
		delete[] memblock;

		double sum = 0;
		double prob;
	}
	file1.close();
	ht.export_table(argv[3]);
}