#include <iostream>
#include <unordered_map>
#include <string>
#include <fstream>
#include "Hashtable.h"
using namespace std;


//map<char *, int, cmp_str> BlahBlah;

unordered_map<__int64, __int64> htmap;


/*
* Get value of a key
*/
__int64 Hashtable::get(__int64 key) {
	try {
		return(htmap.at(key));
	}
	catch (out_of_range) {
		return(NULL);
	}
}

/*
* Check if key exists
* Returns 0 if no, 1 if yes
*/
int Hashtable::check(__int64 key) {
	if (htmap.find(key) == htmap.end()) {
		return(0);
	}
	else {
		return(1);
	}
}

/*
* Counts a key one up
*/
void Hashtable::plus_one(__int64 key) {
	try {
		htmap.at(key) += 1;
	}
	catch (out_of_range) {
		htmap.emplace(key, 1);
	}
}

/*
* Exports Hashtable as csv
* Returns 0 at success otherwise 1
*/
int Hashtable::export_table(char *filename) {
	ofstream file(filename);
	if (file.is_open())
	{
		for (auto it = htmap.begin(); it != htmap.end(); ++it) {
			file << it->first << ";" << it->second << endl;
		}
		file.close();
		return(0);
	}
	else {
		return(1);
	}
}
